//+------------------------------------------------------------------+
//|                                           High-Low Activator.mq4 |
//|                                       Copyright 2012, Peperlizio |
//|                                                            v:1.1 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, Peperlizio"
#property link      ""

#property indicator_buffers   1
#property indicator_color1    Gold
#property indicator_width1    2
#property indicator_style1    STYLE_SOLID
#property indicator_chart_window

//----Extern Variables
extern int    MAPeriod   = 3;
extern string __________ = "0:Simple, 1:Exponential, 2:Smoothed, 3:Linear";
extern int    MAMethod   = 0;
extern string _________  = "M0:Current TF - M1 - M5 - M15 - M30 - H1 - H4 - D1 - W1 - MN1";
extern string TimeFrame  = "M0";

//----Buffers
double MA[];

//----Global Variables
int      TF;
bool     Flag;
double   MABef;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {   
   SetIndexBuffer(0, MA);
   Flag     = false;
   MABef    = 0;
   
   if (TimeFrame == "M0"  || TimeFrame == "m0" ) {TF = Period();   Flag = true;}
   if (TimeFrame == "M1"  || TimeFrame == "m1" ) {TF = PERIOD_M1;  Flag = true;}
   if (TimeFrame == "M5"  || TimeFrame == "m5" ) {TF = PERIOD_M5;  Flag = true;}
   if (TimeFrame == "M15" || TimeFrame == "m15") {TF = PERIOD_M15; Flag = true;}
   if (TimeFrame == "M30" || TimeFrame == "m30") {TF = PERIOD_M30; Flag = true;}
   if (TimeFrame == "H1"  || TimeFrame == "h1" ) {TF = PERIOD_H1;  Flag = true;}
   if (TimeFrame == "H4"  || TimeFrame == "h4" ) {TF = PERIOD_H4;  Flag = true;}
   if (TimeFrame == "D1"  || TimeFrame == "d1" ) {TF = PERIOD_D1;  Flag = true;}
   if (TimeFrame == "W1"  || TimeFrame == "w1" ) {TF = PERIOD_W1;  Flag = true;}
   if (TimeFrame == "MN1" || TimeFrame == "mn1") {TF = PERIOD_MN1; Flag = true;}
   
   if (!Flag) Alert("Timeframe non riconosciuto.");
   
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   if (TF < Period() || !Flag) return(0);
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(MathMax(Bars-counted_bars,3*TF/Period()),Bars-1);
      
   
   for (i=limit; i>=0; i--) {Calc(i);} 
   return(0);
  }
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| Functions                                                        |
//+------------------------------------------------------------------+

//----Calc
void Calc (int Shift)
 {
  int c;                                                 // c --> "i" higher Timeframe Counterpart
  double OpeN, ClosE, MALow, MAHigh;
  
//  if (Shift == 0) {MA[Shift] = MA[Shift+1]; return(0);}
  
  c = iBarShift(NULL,TF,Time[Shift]);
//  if (TF!=Period() && c==0) c = 1;
     
  OpeN   = iOpen (NULL,TF,c); 
  ClosE  = iClose(NULL,TF,c);
  MALow  = iMA   (NULL,TF,MAPeriod,0,MAMethod,3,c);
  MAHigh = iMA   (NULL,TF,MAPeriod,0,MAMethod,2,c);
     
  if (ClosE > MA[Shift+1]) MA[Shift] = MALow;  
  if (ClosE < MA[Shift+1]) MA[Shift] = MAHigh; 
  if (ClosE == MA[Shift+1] && OpeN > ClosE)  MA[Shift] = MALow;
  if (ClosE == MA[Shift+1] && OpeN < ClosE)  MA[Shift] = MAHigh;
  if (ClosE == MA[Shift+1] && OpeN == ClosE) MA[Shift] = MA[Shift+1];
     
  //----X Debug
  /*
  datetime TimE = iTime(NULL,0,i);
  if (TimeToStr(TimE) == "2012.08.31 19:42") Alert(c);  
  */
   
  return(0);
 }